
YssCompare = CreateFrame("Frame")
local YssCompare = YssCompare
YssCompare:SetScript("OnEvent", function(self, event, ...) if self[event] then return self[event](self, event, ...) end end)
function YssCompare:Print(...) ChatFrame1:AddMessage("|cFF33FF99Broker: YssCompare|r: "..string.join(", ", ...)) end
YssCompare:RegisterEvent("ADDON_LOADED")

local LQT = LibStub('LibQTip-1.0')
local broker = LibStub("LibDataBroker-1.1")
local icon = LibStub("LibDBIcon-1.0")
local StatLogic = LibStub("LibStatLogic-1.1")
LibStub("AceComm-3.0"):Embed(YssCompare)
LibStub("AceSerializer-3.0"):Embed(YssCompare)

local YCtooltip -- our LQT tooltip

local IPcache = {}
setmetatable(IPcache, {__mode = "kv"})

YssCompare.bagitems = {} -- store our bag items here no need to save them between sessions
local Proc -- temp storage for proc editing
local ProcItem -- temp storage for the ItemId of the proc
local lineloc -- line to equiploc storage

local Stats = { -- Tier1 Stats pulled from LibStatLogic
		"EMPTY_SOCKET_RED",
		"EMPTY_SOCKET_YELLOW",
		"EMPTY_SOCKET_BLUE",
		"EMPTY_SOCKET_META",

		"IGNORE_ARMOR",
		"MOD_THREAT",
		"STEALTH_LEVEL",
		"MELEE_DMG",
		"RANGED_DMG",
		"MOUNT_SPEED",
		"RUN_SPEED",

		"STR",
		"AGI",
		"STA",
		"INT",
		"SPI",
		"ARMOR",
		"ARMOR_BONUS",

		"FIRE_RES",
		"NATURE_RES",
		"FROST_RES",
		"SHADOW_RES",
		"ARCANE_RES",

		"FISHING",
		"MINING",
		"HERBALISM",
		"SKINNING",

		"BLOCK_VALUE",

		"AP",
		"RANGED_AP",
		"FERAL_AP",
		"AP_UNDEAD",
		"AP_DEMON",

		"HEAL",

		"SPELL_DMG",
		"SPELL_DMG_UNDEAD",
		"SPELL_DMG_DEMON",
		"HOLY_SPELL_DMG",
		"FIRE_SPELL_DMG",
		"NATURE_SPELL_DMG",
		"FROST_SPELL_DMG",
		"SHADOW_SPELL_DMG",
		"ARCANE_SPELL_DMG",

		"SPELLPEN",

		"HEALTH",
		"MANA",
		"HEALTH_REG",
		"MANA_REG",

		"MAX_DAMAGE",
		"DPS",

		"DEFENSE_RATING",
		"DODGE_RATING",
		"PARRY_RATING",
		"BLOCK_RATING",
		"MELEE_HIT_RATING",
		"RANGED_HIT_RATING",
		"SPELL_HIT_RATING",
		"MELEE_HIT_AVOID_RATING",
		"RANGED_HIT_AVOID_RATING",
		"SPELL_HIT_AVOID_RATING",
		"MELEE_CRIT_RATING",
		"RANGED_CRIT_RATING",
		"SPELL_CRIT_RATING",
		"MELEE_CRIT_AVOID_RATING",
		"RANGED_CRIT_AVOID_RATING",
		"SPELL_CRIT_AVOID_RATING",
		"RESILIENCE_RATING",
		"MELEE_HASTE_RATING",
		"RANGED_HASTE_RATING",
		"SPELL_HASTE_RATING",
		"DAGGER_WEAPON_RATING",
		"SWORD_WEAPON_RATING",
		"2H_SWORD_WEAPON_RATING",
		"AXE_WEAPON_RATING",
		"2H_AXE_WEAPON_RATING",
		"MACE_WEAPON_RATING",
		"2H_MACE_WEAPON_RATING",
		"GUN_WEAPON_RATING",
		"CROSSBOW_WEAPON_RATING",
		"BOW_WEAPON_RATING",
		"FERAL_WEAPON_RATING",
		"FIST_WEAPON_RATING",
		"STAFF_WEAPON_RATING",
		"EXPERTISE_RATING",
		"ARMOR_PENETRATION_RATING",
}
local L_Stats = {} -- Localized stats
for i,stat in ipairs(Stats) do
	L_Stats[i] = StatLogic:GetStatNameFromID(stat)
end

local equipLocs = {
	["INVTYPE_AMMO"]           = 0,
	["INVTYPE_GUNPROJECTILE"]  = 0,
	["INVTYPE_BOWPROJECTILE"]  = 0,
	["INVTYPE_HEAD"]           = 1,
	["INVTYPE_NECK"]           = 2,
	["INVTYPE_SHOULDER"]       = 3,
	["INVTYPE_BODY"]           = 4,
	["INVTYPE_CHEST"]          = 5,
	["INVTYPE_ROBE"]           = 5,
	["INVTYPE_WAIST"]          = 6,
	["INVTYPE_LEGS"]           = 7,
	["INVTYPE_FEET"]           = 8,
	["INVTYPE_WRIST"]          = 9,
	["INVTYPE_HAND"]           = 10,
	["INVTYPE_FINGER"]         = {11,12},
	["INVTYPE_TRINKET"]        = {13,14},
	["INVTYPE_CLOAK"]          = 15,
	["INVTYPE_WEAPON"]         = {16,17},
	["INVTYPE_2HWEAPON"]       = {16,17},
	["INVTYPE_WEAPONMAINHAND"] = 16,
	["INVTYPE_WEAPONOFFHAND"]  = 17,
	["INVTYPE_SHIELD"]         = 17,
	["INVTYPE_HOLDABLE"]       = 17,
	["INVTYPE_RANGED"]         = 18,
	["INVTYPE_RANGEDRIGHT"]    = 18,
	["INVTYPE_RELIC"]          = 18,
	["INVTYPE_GUN"]            = 18,
	["INVTYPE_CROSSBOW"]       = 18,
	["INVTYPE_WAND"]           = 18,
	["INVTYPE_THROWN"]         = 18,
	["INVTYPE_TABARD"]         = 19,
}

local MenuParent, MenuItem, MenuItemLoc

YssCompare.ItemDropDownMenu = CreateFrame("Frame", "YssCompare_ItemDropDownMenu")
YssCompare.ItemDropDownMenu.displayMode = "MENU"
YssCompare.ItemDropDownMenu.onHide = function(...)
	MenuParent = nil
	MenuItem = nil
	MenuEquipSlot = nil
end
local IDDMinfo = {}
YssCompare.ItemDropDownMenu.initialize = function(self, level)
	if not level then return end
	wipe(IDDMinfo)
	if level == 1 then
		-- Create the title of the menu
		IDDMinfo.isTitle = 1
		IDDMinfo.text = "Item Options for:"
		IDDMinfo.notCheckable = 1
		UIDropDownMenu_AddButton(IDDMinfo, level)
		
		IDDMinfo.text = MenuItem
		UIDropDownMenu_AddButton(IDDMinfo, level)
		
		IDDMinfo.disabled     = nil
		IDDMinfo.isTitle      = nil
		IDDMinfo.notCheckable = nil
		
		IDDMinfo.text = "Blacklist Exact Item"
		IDDMinfo.arg1 = MenuItem
		IDDMinfo.func = function(button, arg1)
			YssCompare.db.profile.blacklist[arg1] = true
			YssCompare:RefreshTooltip()
		end
		IDDMinfo.checked = nil
		UIDropDownMenu_AddButton(IDDMinfo, level)
		
		IDDMinfo.text = "Blacklist Item by ID only"
		IDDMinfo.arg1 = MenuItem
		IDDMinfo.func = function(button, arg1)
			local id = string.match(arg1, 'item:(%d+)')
			YssCompare.db.profile.blacklistID[id] = true
			YssCompare:RefreshTooltip()
		end
		IDDMinfo.checked = nil
		UIDropDownMenu_AddButton(IDDMinfo, level)
		
		IDDMinfo.text = "Config Item Proc"
		IDDMinfo.arg1 = MenuItem
		IDDMinfo.func = function(button, arg1)
			if YssCompare.db.profile.itemprocslist[arg1] then
				Proc = {
					['Stat'] = YssCompare.db.profile.itemprocslist[arg1].Stat,
					['Size'] = YssCompare.db.profile.itemprocslist[arg1].Size,
					['Duration'] = YssCompare.db.profile.itemprocslist[arg1].Duration,
					['Stacks'] = YssCompare.db.profile.itemprocslist[arg1].Stacks,
					['Cooldown'] = YssCompare.db.profile.itemprocslist[arg1].Cooldown,
				}
			else
				Proc = {
					['Stat'] = nil,
					['Size'] = 0,
					['Duration'] = 0,
					['Stacks'] = 1,
					['Cooldown'] = 0,
				}
			end
			ProcItem = arg1
			LibStub("AceConfigDialog-3.0"):Open('YssCompareProcOptions')
		end
		IDDMinfo.checked = nil
		UIDropDownMenu_AddButton(IDDMinfo, level)

		IDDMinfo.text = "Equip Item"
		IDDMinfo.arg1 = MenuItem
		IDDMinfo.arg2 = MenuItemLoc
		IDDMinfo.func = function(button, arg1, arg2)
			EquipItemByName(arg1, arg2)
		end
		IDDMinfo.checked = nil
		UIDropDownMenu_AddButton(IDDMinfo, level)
		
		-- Close menu item
		IDDMinfo.text         = CLOSE
		IDDMinfo.func         = function() CloseDropDownMenus() end
		IDDMinfo.checked      = nil
		IDDMinfo.notCheckable = 1
		UIDropDownMenu_AddButton(IDDMinfo, level)
	end
end


local ItemCell, cellPrototype = LQT:CreateCellProvider()

function cellPrototype:InitializeCell()
	self:SetHeight(30)
	self.icon = self:CreateTexture(nil, 'ARTWORK')
	self.icon:SetHeight(30)
	self.icon:SetWidth(30)
	self.icon:SetPoint("LEFT", self, "LEFT")
	
	self.border = self:CreateTexture(nil, 'OVERLAY')
	self.border:SetTexture("Interface\\Buttons\\UI-ActionButton-Border")
	self.border:SetBlendMode("ADD")
	self.border:SetAlpha(0.75)
	self.border:SetHeight(30*68/37)
	self.border:SetWidth(30*68/37)
	self.border:SetPoint("CENTER",self.icon,"CENTER")
	

	self.value = self:CreateFontString()
	self.value:SetPoint("BOTTOM", self, "BOTTOM")
	self.value:SetPoint("TOP", self, "TOP")
	self.value:SetPoint("LEFT", self.icon, "RIGHT")
	self.value:SetPoint("RIGHT", self, "RIGHT",-2,0)
	self.value:SetFontObject(GameTooltipText)
	self.link = nil
	self.points = 0
end

function cellPrototype:SetupCell(tooltip, link, justification, font, points)
	local value = self.value
	local icon = self.icon

	value:SetFontObject(font or tooltip:GetFont())
	value:SetJustifyH("RIGHT")
	value:SetText(tostring(points or self.points))
	value:Show()

	icon:SetTexture(GetItemIcon(link) or self.link)
	
	local _, _, itemRarity = GetItemInfo(link) 
	if itemRarity then
		local r, g, b, _ = GetItemQualityColor(itemRarity)
		self.border:SetVertexColor(r, g, b)
		self.border:Show()
	else
		self.border:Hide()
	end
	local width = value:GetStringWidth() + 34
	self.link = link
	self.points = points
	return width, self:GetHeight()
end

function cellPrototype:ReleaseCell()
	self.link = nil
	self.points = 0
end

local origs = {}
local function OnTooltipSetItem(tooltip, ...)
	local name, link = tooltip:GetItem()
	if IsEquippableItem(link) then
		local itempoints = YssCompare:YssItemPoints(link, true, true, true)
		local _, _, _, _, _, _, _, _, itemEquipLoc = GetItemInfo(link)
		local r,g,b = YssCompare.db.profile.r, YssCompare.db.profile.g, YssCompare.db.profile.b
		if type(equipLocs[itemEquipLoc]) == 'table' then
			local comparepoints = {}
			comparepoints[1] = YssCompare:YssItemPoints(GetInventoryItemLink("player", equipLocs[itemEquipLoc][1]), true, true, true)
			comparepoints[2] = YssCompare:YssItemPoints(GetInventoryItemLink("player", equipLocs[itemEquipLoc][2]), true, true, true)
			if comparepoints[1] == 0 and comparepoints[2] == 0 then
				comparepoints[1] = nil
				comparepoints[2] = nil
			elseif comparepoints[2] == 0 then
				comparepoints[2] = nil
			end
			if comparepoints[1] and comparepoints[2] then
				tooltip:AddDoubleLine('YssCompare:', string.format("|cff8080ff%.6g|r(%s/%s)", itempoints, YssCompare:ColorNum(itempoints-comparepoints[1]), YssCompare:ColorNum(itempoints-comparepoints[2])),r,g,b,r,g,b)
			elseif comparepoints[1] or comparepoints[2] then
				tooltip:AddDoubleLine('YssCompare:', string.format("|cff8080ff%.6g|r(%s)", itempoints, YssCompare:ColorNum(itempoints-(comparepoints[1] or comparepoints[2]))),r,g,b,r,g,b)
			else
				tooltip:AddDoubleLine('YssCompare:', string.format("|cff8080ff%.6g|r", itempoints),r,g,b,r,g,b)
			end
			--Spew('loc', itemEquipLoc)--INVTYPE_2HWEAPON
		else
			if GetInventoryItemLink("player", equipLocs[itemEquipLoc]) then
				local comparepoints = itempoints-YssCompare:YssItemPoints(GetInventoryItemLink("player", equipLocs[itemEquipLoc]), true, true, true)
				tooltip:AddDoubleLine('YssCompare:', string.format("|cff8080ff%.6g|r(%s)", itempoints, YssCompare:ColorNum(comparepoints)),r,g,b,r,g,b)
			else
				tooltip:AddDoubleLine('YssCompare:', string.format("|cff8080ff%.6g|r", itempoints),r,g,b,r,g,b)
			end
		end
		--Spew('YssCompareTEST', YssCompareItemSource)
		
		--tooltip:Show()
	end
	if origs[tooltip] then return origs[tooltip](tooltip, ...) end
end


for _,tooltip in pairs{GameTooltip, ItemRefTooltip, ShoppingTooltip1, ShoppingTooltip2,AtlasLootTooltip} do
	if tooltip then
		origs[tooltip] = tooltip:GetScript("OnTooltipSetItem")
		tooltip:SetScript("OnTooltipSetItem", OnTooltipSetItem)
	end
end

function YssCompare:ColorNum(num)
	if num > 0 then
		return string.format(GREEN_FONT_COLOR_CODE..'+%.6g|r' , num)
	elseif num < 0 then
		return string.format(RED_FONT_COLOR_CODE..'%.6g|r' , num)
	else
		return string.format(HIGHLIGHT_FONT_COLOR_CODE..'%.6g|r' , num)
	end
end

function YssCompare:ColorNum2dec(num)
	if num > 0 then
		return string.format(GREEN_FONT_COLOR_CODE..'+%.2f|r' , num)
	elseif num < 0 then
		return string.format(RED_FONT_COLOR_CODE..'%.2f|r' , num)
	else
		return string.format(HIGHLIGHT_FONT_COLOR_CODE..'%.2f|r' , num)
	end
end


local YssCompareItem = {}
function YssCompare:YssItemPoints(link, removeEnchant, removeGems, defaulGems)
	if not link then return 0 end
	local cacheID = tostring(link)..tostring(removeEnchant)..tostring(removeGems)..tostring(defaulGems)
	if IPcache[cacheID] then return IPcache[cacheID] end
	wipe(YssCompareItem)
	if removeEnchant then
		link = StatLogic:RemoveEnchant(link)
	end
	if removeGems then
		link = StatLogic:RemoveGem(link)
	end
	if defaulGems then
		local redID = StatLogic:GetGemID(self.sets[self.db.profile.WeightSet].gems.EMPTY_SOCKET_RED)
		local yellowID = StatLogic:GetGemID(self.sets[self.db.profile.WeightSet].gems.EMPTY_SOCKET_YELLOW)
		local blueID = StatLogic:GetGemID(self.sets[self.db.profile.WeightSet].gems.EMPTY_SOCKET_BLUE)
		local metaID = StatLogic:GetGemID(self.sets[self.db.profile.WeightSet].gems.EMPTY_SOCKET_META)
		link = StatLogic:BuildGemmedTooltip(link , redID, yellowID, blueID, metaID)
	end
	
	StatLogic:GetSum(link, YssCompareItem)
	local Points = 0
	
	local procstat, procval = self:YssProcValue(link)
	if procstat then YssCompareItem[procstat] = YssCompareItem[procstat] and YssCompareItem[procstat] + procval or procval end
	for stat , val in pairs(YssCompareItem) do
		if self.sets[self.db.profile.WeightSet].stats[stat] then
			Points = Points + (val * self.sets[self.db.profile.WeightSet].stats[stat])
		end
	end
	IPcache[cacheID] = Points
	return Points
end

-- somewhat expensive function so do not call it too often
function YssCompare:YssSetInfo(linktable, removeEnchant, removeGems, defaulGems)
	local stats = {
		['Normal'] = {},
		['Total'] = {},
		['Points'] = {},
	}
	for i, link in pairs(linktable) do
		if removeEnchant then
			link = StatLogic:RemoveEnchant(link)
		end
		if removeGems then
			link = StatLogic:RemoveGem(link)
		end
		if defaulGems then
			local redID = StatLogic:GetGemID(self.sets[self.db.profile.WeightSet].gems.EMPTY_SOCKET_RED)
			local yellowID = StatLogic:GetGemID(self.sets[self.db.profile.WeightSet].gems.EMPTY_SOCKET_YELLOW)
			local blueID = StatLogic:GetGemID(self.sets[self.db.profile.WeightSet].gems.EMPTY_SOCKET_BLUE)
			local metaID = StatLogic:GetGemID(self.sets[self.db.profile.WeightSet].gems.EMPTY_SOCKET_META)
			link = StatLogic:BuildGemmedTooltip(link , redID, yellowID, blueID, metaID)
		end
		StatLogic:GetSum(link, YssCompareItem)
		for stat, val in pairs(YssCompareItem) do
			stats.Normal[stat] = stats.Normal[stat] and stats.Normal[stat] + tonumber(val) or tonumber(val)
			stats.Total[stat] = stats.Total[stat] and stats.Total[stat] + tonumber(val) or tonumber(val)
		end
		local procstat, procval = self:YssProcValue(link)
		if procstat then
			stats.Proc = stats.Proc or {}
			stats.Proc[procstat] = stats.Proc[procstat] and stats.Proc[procstat] + procval or procval
			stats.Total[procstat] = stats.Total[procstat] and stats.Total[procstat] + procval or procval
		end
	end
	local Points, ExtraPoints = 0, nil
	for stat , val in pairs(stats.Total) do
		if self.sets[self.db.profile.WeightSet].stats[stat] then
			local cap = self.sets[self.db.profile.WeightSet].statcaps[stat] or math.huge
			local extraval = 0
			if val > cap then
				stats.Extra = stats.Extra or {}
				stats.ExtraPoints = stats.ExtraPoints or {}
				stats.Extra[stat] = (val-cap)
				stats.ExtraPoints[stat] = (val-cap) * self.sets[self.db.profile.WeightSet].stats[stat]
				val = cap
				stats.Total[stat] = val
			end
			stats.Points[stat] = val * self.sets[self.db.profile.WeightSet].stats[stat]
		end
	end
	for stat, p in pairs(stats.Points) do
		Points = Points + p
	end
	if stats.ExtraPoints then
		ExtraPoints = 0
		for stat, p in pairs(stats.ExtraPoints) do
			ExtraPoints = ExtraPoints + p
		end
	end
	return Points, ExtraPoints, stats
end

function YssCompare:YssProcValue(link)
	if not link or  not self.db.profile.itemprocslist[link] then return nil end
	local proc = self.db.profile.itemprocslist[link]
	if proc.Stacks > 1 then
		return proc.Stat, proc.Stacks*proc.Size
	elseif proc.Cooldown == 0  then
		return proc.Stat, proc.Size
	else
		return proc.Stat, (1/proc.Cooldown)*proc.Duration*proc.Size
	end
end

function YssCompare:YssEquipedPoints()
	local inventory = {}
	for i=1,19 do
		inventory[i] = GetInventoryItemLink("player", i)
	end
	local points, extrapoints, stats = self:YssSetInfo(inventory)
	return points, extrapoints, stats
end

function YssCompare:ADDON_LOADED(event, addon)
	if addon == "YssCompare" then
		
		self:UnregisterEvent("ADDON_LOADED")
		self.ADDON_LOADED = nil
		if IsLoggedIn() then self:PLAYER_LOGIN() else self:RegisterEvent("PLAYER_LOGIN") end
	end
end

local YCHoverTip

local function HideHoverTip()
	YCHoverTip = LQT:Release( YCHoverTip )
end

-- /spew YCSTATS
local function ShowHoverTip(anchor)
	if YCHoverTip then HideHoverTip() end
	local Points, extraPoints, statsT = YssCompare:YssEquipedPoints()
	local Cols = {
		[1] = 'stat',
		[2] = 'Normal',
		[3] = 'Total',
		[4] = 'Points',
	}
	local Color = {
		[1] = '|cffffd200%s|r',
		[2] = '|cffffffff%i|r',
		[3] = '|cffffffff%i|r',
		[4] = '|cffffffff%.2f|r',
	}
	if statsT.Extra then
		table.insert(Cols, 4, 'Extra')
		table.insert(Color, 4, '|cffff2020%.2f|r')
		table.insert(Cols, 6, 'ExtraPoints')
		table.insert(Color, 6, '|cffff2020%.2f|r')
	end
	if statsT.Proc then
		table.insert(Cols, 3, 'Proc')
		table.insert(Color, 3, '|cffffffff%i|r')
	end
	local Col = #Cols
	YCHoverTip = LQT:Acquire("YssCompareHT", Col, "RIGHT", "RIGHT", "RIGHT", "RIGHT", "RIGHT", "RIGHT", "RIGHT")
	YCHoverTip:SetScale(YssCompare.db.profile.Scale)
	YCHoverTip:AddHeader('')
	YCHoverTip:AddLine('')
	for i=2,Col do
		YCHoverTip:SetCell(2, i, string.format(Color[1], Cols[i]), nil, 'CENTER')
	end
	local line = 3
	local coloredline = false
	for statid,stat in ipairs(Stats) do
		if statsT.Total[stat] then
			YCHoverTip:AddLine('')
			YCHoverTip:SetCell(line, 1, string.format(Color[1], L_Stats[statid]))
			for i=2,Col do
				if statsT[Cols[i]][stat] then
					YCHoverTip:SetCell(line, i, string.format(Color[i], tostring(statsT[Cols[i]][stat])))
				end
			end
			if coloredline then
				YCHoverTip:SetLineColor(line, 1,1,1,.25)
			end
			coloredline = not coloredline
			line = line + 1
		end
	end
	YCHoverTip:AddLine('')
	if statsT.Extra then
		YCHoverTip:SetCell(YCHoverTip:GetLineCount(), Col-2, string.format(NORMAL_FONT_COLOR_CODE..'%s|r', 'Total:'))
		YCHoverTip:SetCell(YCHoverTip:GetLineCount(), Col-1, string.format(GREEN_FONT_COLOR_CODE..'%.2f|r', Points))
		YCHoverTip:SetCell(YCHoverTip:GetLineCount(), Col, string.format(RED_FONT_COLOR_CODE..'%.2f|r', extraPoints))
	else
		YCHoverTip:SetCell(YCHoverTip:GetLineCount(), Col-1, string.format(NORMAL_FONT_COLOR_CODE..'%s|r', 'Total:'))
		YCHoverTip:SetCell(YCHoverTip:GetLineCount(), Col, string.format(GREEN_FONT_COLOR_CODE..'%.2f|r', Points))
	end
	
	YCHoverTip:SetCell(1, 1, "|cffff8000YssCompare|r", GameTooltipHeaderText, 'CENTER', Col)
	YCHoverTip:AddLine('')
	YCHoverTip:SetCell(YCHoverTip:GetLineCount(), 1, "|cffffff00Click|r to toggle YssCompare", nil, 'CENTER', Col)
	YCHoverTip:AddLine('')
	YCHoverTip:SetCell(YCHoverTip:GetLineCount(), 1, "|cffffff00Right-click|r to open the options menu", nil, 'CENTER', Col)
	
	YCHoverTip:SmartAnchorTo(anchor)
	YCHoverTip:Show()
end

function YssCompare:PLAYER_LOGIN(event, addon)
	self:RegisterComm('YComp', 'OnCommReceived')
	YssCompare_Sets = YssCompare_Sets or {
		["Default"] = {
			["stats"] = {},
			["statcaps"] = {},
			["gems"] = {},
		},
	}
	self.sets = YssCompare_Sets
	
	local defaults = {
		["profile"] = {
			['r'] = 1,
			['g'] = .5,
			['b'] = 0,
			['bagr'] = 0,
			['bagg'] = 1,
			['bagb'] = 1,
			['bankr'] = 1,
			['bankg'] = 0,
			['bankb'] = 1,
			["WeightSet"] = 'Default',
			['Scale'] = .8,
			['blacklist'] = {},
			['blacklistID'] = {},
			['itemprocslist'] = {},
		},
	}
	self.db = LibStub("AceDB-3.0"):New("YssCompare_DB", defaults)
	self.db:RegisterCallback("OnProfileChanged", function() YssCompare:ReloadOptions() end)
	self.db:RegisterCallback("OnProfileCopied", function() YssCompare:ReloadOptions() end)
	self.db:RegisterCallback("OnProfileReset", function() YssCompare:ReloadOptions() end)
	
	--TipHooker:Hook(self.ProcessTooltip, "item")
	self:SetupStatOptions()
	
	
	self.obj = LibStub("LibDataBroker-1.1"):NewDataObject("YssCompare", {
		icon = "Interface\\AddOns\\YssCompare\\icon",
		label = "|cffff8000YssCompare|r",
		type = "data source",
		text  = "0",
		OnEnter = ShowHoverTip,
		OnLeave = HideHoverTip,
		OnClick = function(clickedFrame, button)
			if button == "RightButton" then 
				InterfaceOptionsFrame_OpenToCategory(YssCompare.optframe.YssCompare)
			else
				if YCtooltip then
					YssCompare:HideTooltip()
				else
					YssCompare:ShowTooltip(clickedFrame)
				end
			end
		end
	})
	self:RegisterModuleOptions('share', YssCompare.ShareOptions, 'Share')
	self:RegisterModuleOptions('profile', LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db), 'Profile')
	self:ReloadOptions()
	YssCompare:RegisterEvent("BAG_UPDATE")
	YssCompare:RegisterEvent("BANKFRAME_OPENED")
	YssCompare:RegisterEvent("UNIT_INVENTORY_CHANGED")
	self:UNIT_INVENTORY_CHANGED()
	self:UnregisterEvent("PLAYER_LOGIN")
	self.PLAYER_LOGIN = nil
end

function YssCompare:UNIT_INVENTORY_CHANGED()
	local points, extrapoints = self:YssEquipedPoints()
	if extrapoints then
		self.obj.text = string.format(GREEN_FONT_COLOR_CODE..'%.2f|r('..RED_FONT_COLOR_CODE..'+%.2f|r)' , points, extrapoints)
	else
		self.obj.text = string.format(GREEN_FONT_COLOR_CODE..'%.2f|r' , points)
	end
	self:RefreshTooltip()
end

function YssCompare:BANKFRAME_OPENED()
	for i = NUM_BAG_SLOTS+1, NUM_BAG_SLOTS+NUM_BANKBAGSLOTS do
		self:BAG_UPDATE(nil,i)
	end
	self:BAG_UPDATE(nil,BANK_CONTAINER)
end

local login = true
function YssCompare:BAG_UPDATE(event,bag)
	if login then
		login = false
		self:BAG_UPDATE(event,0)
	end
	if bag >= -1 then
		local storage
		if bag >=0 and bag <= NUM_BAG_SLOTS then
			storage = self.bagitems
		else
			storage = self.db.char
		end
		storage[bag] = {}
		local link
		for i=1,GetContainerNumSlots(bag) do
			link = GetContainerItemLink(bag, i)
			if IsEquippableItem(link) then
				storage[bag][link] = i
			end
		end
		if not next(storage[bag]) then storage[bag] = nil end
	end
	YssCompare:RefreshTooltip()
end

local function itemsort(a,b)
	return YssCompare:YssItemPoints(a) > YssCompare:YssItemPoints(b)
end

local temp = {}
function YssCompare:GetSortedLinkList(equipLoc, bank)
	local storage
	if bank then
		storage = self.db.char
	else
		storage = self.bagitems
	end
	local t = {}
	wipe(temp)
	for bag,bagT in pairs(storage) do
		for item,slot in pairs(bagT) do
			local _, _, _, _, _, _, _, _, itemEquipLoc = GetItemInfo(item)
			local id = string.match(item, 'item:(%d+)')
			if equipLoc == itemEquipLoc and not temp[item] and not self.db.profile.blacklist[item] and not self.db.profile.blacklistID[id] then
				t[#t+1] = item
				temp[item] = true
			end
		end
	end
	table.sort(t,itemsort)
	return t
end

local dummyframe = CreateFrame('Frame')
dummyframe:Hide()
_G['YssCompareFrame'] = dummyframe
tinsert(UISpecialFrames,"YssCompareFrame")

local function YssCompare_Enter(cell, itemLink, ...)
	GameTooltip:SetOwner(cell, "ANCHOR_NONE")
	GameTooltip:ClearAllPoints()
	local x, y = cell:GetCenter()
	local vertical
	if y < GetScreenHeight() / 2 then
		vertical = "BOTTOM"
	else
		vertical = "TOP"
	end
	if x < GetScreenWidth() / 2 then
		GameTooltip:SetPoint(vertical.."LEFT", cell, vertical.."RIGHT")
	else
		GameTooltip:SetPoint(vertical.."RIGHT", cell, vertical.."LEFT")
	end
	if IsModifiedClick("DRESSUP") then
		ShowInspectCursor();
	end
	GameTooltip:SetHyperlink(itemLink)
end

local function YssCompare_Leave(cell, itemLink, ...)
	ResetCursor()
	GameTooltip:ClearLines()
	GameTooltip:Hide()
end

local function YssCompare_Click(cell, itemLink, button)
	if button == "RightButton" then
		if MenuParent == cell then
			CloseDropDownMenus()
			MenuParent = nil
		else 
			CloseDropDownMenus()
			MenuParent = cell
			MenuItem = itemLink
			MenuItemLoc = lineloc[cell._line]
			ToggleDropDownMenu(1, nil, YssCompare_ItemDropDownMenu, cell, 0, 0)
		end
	else
		HandleModifiedItemClick(itemLink)
	end
end

local YCTanchorFrame

function YssCompare:RefreshTooltip()
	if not YCTanchorFrame then return end
	self:ShowTooltip(YCTanchorFrame)
end

function YssCompare:ShowTooltip(anchorFrame)
	if YCtooltip then self:HideTooltip() end
	YCTanchorFrame = anchorFrame
	YCtooltip = LQT:Acquire("YssCompareTT", 2, "RIGHT", "CENTER")
	YCtooltip:SetFrameStrata('FULLSCREEN_DIALOG')
	YCtooltip:SetScale(self.db.profile.Scale)
	YCtooltip:SetScript('OnHide', YssCompare.HideTooltip)
	YCtooltip:AddHeader("|cffff8000YssCompare|r")
	YCtooltip:AddLine('', 'Equiped')
	local coloredline = false
	lineloc = {}
	local loclist = {}
	local locvals = {}
	local itemlists = {}
	for i=1, 19 do
		local link = GetInventoryItemLink("player", i)
		if link then
			local _, _, _, _, _, _, _, _, itemEquipLoc = GetItemInfo(link)
			YCtooltip:AddLine(_G[itemEquipLoc])
			local line = YCtooltip:GetLineCount()
			local val = self:YssItemPoints(link)
			YCtooltip:SetCell(line, 2, link, ItemCell, string.format(GREEN_FONT_COLOR_CODE..'%.2f|r' , val))
			YCtooltip:SetCellScript(line, 2, 'OnEnter', YssCompare_Enter, link)
			YCtooltip:SetCellScript(line, 2, 'OnLeave', YssCompare_Leave, link)
			YCtooltip:SetCellScript(line, 2, 'OnMouseUp', YssCompare_Click, link)
			loclist[line] = itemEquipLoc
			locvals[line] = val
			lineloc[line] = i
			itemlists[itemEquipLoc] = {
				['bag'] = self:GetSortedLinkList(itemEquipLoc),
				['bank'] = self:GetSortedLinkList(itemEquipLoc, true),
			}
			if coloredline then
				YCtooltip:SetLineColor(YCtooltip:GetLineCount(), 1,1,1,.25)
			end
			coloredline = not coloredline
		end
	end
	local points, extrapoints = self:YssEquipedPoints()
	if extrapoints then
		YCtooltip:AddLine('Total:', string.format(GREEN_FONT_COLOR_CODE..'%.2f|r('..RED_FONT_COLOR_CODE..'+%.2f|r)' , points, extrapoints))
	else
		YCtooltip:AddLine('Total:', string.format(GREEN_FONT_COLOR_CODE..'%.2f|r' , points))
	end
	if coloredline then
		YCtooltip:SetLineColor(YCtooltip:GetLineCount(), 1,1,1,.25)
	end
	local extraCol = 0
	for loc,t in pairs(itemlists) do
		if #t.bag + #t.bank > extraCol then
			extraCol = #t.bag + #t.bank
		end
	end
	for i = 1, extraCol do
		YCtooltip:AddColumn()
	end
	YCtooltip:SetCell(1, 1, "|cffff8000YssCompare|r", GameTooltipHeaderText, 'CENTER', 2+extraCol)
	local bagr, bagg, bagb = self.db.profile.bagr, self.db.profile.bagg, self.db.profile.bagb
	local bankr, bankg, bagb = self.db.profile.bankr, self.db.profile.bankg, self.db.profile.bankb
	for line, loc in pairs(loclist) do
		for i,link in ipairs(itemlists[loc].bag) do
			YCtooltip:SetCell(line, 2+i, link, ItemCell, self:ColorNum2dec(self:YssItemPoints(link)-locvals[line]))
			YCtooltip:SetCellColor(line, 2+i, bagr, bagg, bagb, .5)
			YCtooltip:SetCellScript(line, 2+i, 'OnEnter', YssCompare_Enter, link)
			YCtooltip:SetCellScript(line, 2+i, 'OnLeave', YssCompare_Leave, link)
			YCtooltip:SetCellScript(line, 2+i, 'OnMouseUp', YssCompare_Click, link)
		end
		local bagsize = #itemlists[loc].bag
		for i,link in ipairs(itemlists[loc].bank) do
			YCtooltip:SetCell(line, 2+bagsize+i, link, ItemCell, self:ColorNum2dec(self:YssItemPoints(link)-locvals[line]))
			YCtooltip:SetCellColor(line, 2+bagsize+i, bankr, bankg, bagb, .5)
			YCtooltip:SetCellScript(line, 2+bagsize+i, 'OnEnter', YssCompare_Enter, link)
			YCtooltip:SetCellScript(line, 2+bagsize+i, 'OnLeave', YssCompare_Leave, link)
			YCtooltip:SetCellScript(line, 2+bagsize+i, 'OnMouseUp', YssCompare_Click, link)
		end
	end
	
	YCtooltip:SmartAnchorTo(anchorFrame)
	YCtooltip:EnableMouse()
	--YCtooltip:UpdateScrolling(self.db.profile.maxheight)
	YCtooltip:Show()
	_G['YssCompareFrame'] = YCtooltip
end

function YssCompare:HideTooltip()
	YCTanchorFrame = nil
	YCtooltip:SetScript('OnHide', nil)
	YCtooltip = LQT:Release( YCtooltip )
	_G['YssCompareFrame'] = dummyframe
end


function YssCompare:ReloadOptions()

end

do
	local ReverseStats = {}
	for i,stat in ipairs(Stats) do
		ReverseStats[stat] = i
	end
	local SelectedStat
	local StatOptionsTable
	local function Getter(info)
		if YssCompare.sets[YssCompare.db.profile.WeightSet].gems[info[#info]] then
			return tostring(YssCompare.sets[YssCompare.db.profile.WeightSet].gems[info[#info]])
		end
	end
	
	local function Setter(info, val)
		if val == '' then
			YssCompare.sets[YssCompare.db.profile.WeightSet].gems[info[#info]] = nil
		else
			YssCompare.sets[YssCompare.db.profile.WeightSet].gems[info[#info]] = tonumber(val)
		end
		wipe(IPcache)
		YssCompare:UNIT_INVENTORY_CHANGED()
	end
	
	local function Validator(info, val)
		if tonumber(val) or val == '' then
			return true
		else
			return "Input must be a number or and empty input"
		end
	end
	local function Descriptor(info)
		local item = Getter(info)
		if item then
			return select(2,StatLogic:GetGemID(item)).."|nAccepts the gem itemID only"
		end
		return 'Accepts the gem itemID only'
	end
	local function ValidateNum(info, val)
		if tonumber('0'..val) then
			return true
		else
			return "Input must be a number"
		end
	end
	
	local StatWeight = {
			name = function(info) return StatLogic:GetStatNameFromID(info[#info]) end,
			order = function(info)
				return -1*(YssCompare.sets[YssCompare.db.profile.WeightSet].stats[info[#info]] + 1000)
			end,
			type = "group",
			inline = true,
			args = {
				Weight = {
					name = "Weight:",
					order = 1,
					type = 'input',
					width = 'half',
					validate = ValidateNum,
					get = function(info)
						return tostring(YssCompare.sets[YssCompare.db.profile.WeightSet].stats[info[#info-1]])
					end,
					set = function(info,val)
						YssCompare.sets[YssCompare.db.profile.WeightSet].stats[info[#info-1]] = tonumber('0'..val)
						wipe(IPcache)
						YssCompare:UNIT_INVENTORY_CHANGED()
					end,
				},
				Cap = {
					name = "Stat Cap:",
					order = 2,
					type = 'input',
					width = 'half',
					validate = function(info, val)
						if tonumber('0'..val) or val == '' then
							return true
						else
							return "Input must be a number or and empty input"
						end
					end,
					disabled = function(info)
						return not StatLogic:GetRatingIdOrStatId(info[#info-1])
					end,
					hidden = function(info)
						return not StatLogic:GetRatingIdOrStatId(info[#info-1])
					end,
					get = function(info)
						if YssCompare.sets[YssCompare.db.profile.WeightSet].statcaps[info[#info-1]] then
							return tostring(YssCompare.sets[YssCompare.db.profile.WeightSet].statcaps[info[#info-1]])
						end
					end,
					set = function(info,val)
						if val == '' then
							YssCompare.sets[YssCompare.db.profile.WeightSet].statcaps[info[#info-1]] = nil
						else
							YssCompare.sets[YssCompare.db.profile.WeightSet].statcaps[info[#info-1]] = tonumber('0'..val)
						end
						wipe(IPcache)
						YssCompare:UNIT_INVENTORY_CHANGED()
					end,
				},
				Remove = {
					name = "Remove",
					order = 3,
					type = 'execute',
					width = 'half',
					func = function(info)
						YssCompare.sets[YssCompare.db.profile.WeightSet].stats[info[#info-1]] = nil
						YssCompare.sets[YssCompare.db.profile.WeightSet].statcaps[info[#info-1]] = nil
						StatOptionsTable.StatWeights.args[info[#info-1]] = nil
						wipe(IPcache)
						YssCompare:UNIT_INVENTORY_CHANGED()
					end,
				},
			}
	}
	
	function YssCompare:SetupStatOptions()
		StatOptionsTable = {
				EMPTY_SOCKET_RED = {
					name = function(info)
						local item = Getter(info)
						local _, gem
						if item then
							_, gem = GetItemInfo(item)
						end
						if not gem then gem = '' end
						return 'Red Gem: '..gem
					end,
					type = 'input',
					order = 10,
					desc = Descriptor,
					validate = Validator,
					get = Getter,
					set = Setter,
				},
				EMPTY_SOCKET_YELLOW = {
					name = function(info)
						local item = Getter(info)
						local _, gem
						if item then
							_, gem = GetItemInfo(item)
						end
						if not gem then gem = '' end
						return 'Yellow Gem: '..gem
					end,
					type = 'input',
					order = 20,
					desc = Descriptor,
					validate = Validator,
					get = Getter,
					set = Setter,
				},
				EMPTY_SOCKET_BLUE = {
					name = function(info)
						local item = Getter(info)
						local _, gem
						if item then
							_, gem = GetItemInfo(item)
						end
						if not gem then gem = '' end
						return 'Blue Gem: '..gem
					end,
					type = 'input',
					order = 30,
					desc = Descriptor,
					validate = Validator,
					get = Getter,
					set = Setter,
				},
				EMPTY_SOCKET_META = {
					name = function(info)
						local item = Getter(info)
						local _, gem
						if item then
							_, gem = GetItemInfo(item)
						end
						if not gem then gem = '' end
						return 'Meta Gem: '..gem
					end,
					type = 'input',
					order = 40,
					desc = Descriptor,
					validate = Validator,
					get = Getter,
					set = Setter,
				},
				StatsList = {
					name = "Stat:",
					values = L_Stats,
					order = 50,
					type = 'select',
					get = function(info)
						return SelectedStat
					end,
					set = function(info,val)
						SelectedStat = val
					end
				},
				StatAdd = {
					name = "Add",
					order = 60,
					width = 'half',
					type = 'execute',
					disabled = function() return not SelectedStat end,
					func = function()
						YssCompare.sets[YssCompare.db.profile.WeightSet].stats[Stats[SelectedStat]] = 0
						StatOptionsTable.StatWeights.args[Stats[SelectedStat]] = StatWeight
						SelectedStat = nil
					end,
				},
				StatWeights = {
					name = "Stat Weights:",
					type = "group",
					order = 70,
					args = {}
				},
		}
		for stat in pairs(YssCompare.sets[YssCompare.db.profile.WeightSet].stats) do
			StatOptionsTable.StatWeights.args[stat] = StatWeight
		end
		self.MainOption.args.SetSetup.args = StatOptionsTable
	end
	
	function YssCompare:ProcGet(info)
		return tostring(Proc[info[#info]])
	end
	function YssCompare:ProcSet(info, val)
		Proc[info[#info]] = tonumber('0'..val)
	end
	
	YssCompare.ProcOption = {
		name = 'Item Proc',
		type="group",
		handler = YssCompare,
		args = {
			desc = {
				order = 1,
				type = 'header',
				name = function() return string.format('Item Proc Options for: %s', ProcItem) end,
			},
			Stat = {
				name = "Proc Stat:",
				values = L_Stats,
				order = 100,
				type = 'select',
				width = 'double',
				get = function(info)
					return ReverseStats[Proc.Stat]
				end,
				set = function(info,val)
					Proc.Stat = Stats[val]
				end
			},
			Size = {
				name = "Proc Size:",
				order = 200,
				type = 'input',
				width = 'half',
				validate = ValidateNum,
				get = 'ProcGet',
				set = 'ProcSet',
			},
			Duration = {
				name = "Proc Duration:",
				order = 300,
				type = 'input',
				width = 'half',
				validate = ValidateNum,
				get = 'ProcGet',
				set = 'ProcSet',
			},
			Stacks = {
				name = "Proc Stacks:",
				order = 400,
				type = 'input',
				width = 'half',
				validate = ValidateNum,
				get = 'ProcGet',
				set = 'ProcSet',
			},
			Cooldown = {
				name = "Proc Cooldown:",
				order = 500,
				type = 'input',
				width = 'half',
				validate = ValidateNum,
				get = 'ProcGet',
				set = 'ProcSet',
			},
			save = {
				name = SAVE,
				order = 600,
				type = 'execute',
				func = function()
					YssCompare:Print('save and close')
					-- reset the proc table
					YssCompare.db.profile.itemprocslist[ProcItem] = Proc
					LibStub("AceConfigDialog-3.0"):Close('YssCompareProcOptions')
					wipe(IPcache)
					YssCompare:UNIT_INVENTORY_CHANGED()
					YssCompare:RefreshTooltip()
				end,
			},
			delete = {
				name = DELETE,
				order = 700,
				type = 'execute',
				confirm = function()
					return string.format('Are you sure that you want to remove the proc info for %s?', ProcItem)
				end,
				func = function()
					YssCompare:Print('save and close')
					YssCompare.db.profile.itemprocslist[ProcItem] = nil
					LibStub("AceConfigDialog-3.0"):Close('YssCompareProcOptions')
					wipe(IPcache)
					YssCompare:UNIT_INVENTORY_CHANGED()
					YssCompare:RefreshTooltip()
				end,
			},
		}
	}
	LibStub("AceConfig-3.0"):RegisterOptionsTable('YssCompareProcOptions', YssCompare.ProcOption)
	LibStub("AceConfigDialog-3.0"):SetDefaultSize('YssCompareProcOptions', 395, 225)
	
	YssCompare.MainOption = {
		type="group",
		childGroups = 'select',
		handler = YssCompare,
		args = {
			Color = {
				name = "Tooltip Line Color",
				type = 'color',
				order = 1,
				get = function(info)
					return YssCompare.db.profile.r, YssCompare.db.profile.g, YssCompare.db.profile.b
				end,
				set = function(info,r,g,b)
					YssCompare.db.profile.r, YssCompare.db.profile.g, YssCompare.db.profile.b = r,g,b
				end,
			},
			NewSet = {
				name = "New Weight Set:",
				order = 100,
				type = 'input',
				set = function(info, val)
					YssCompare.sets[val] = {
						["stats"] = {},
						["statcaps"] = {},
						["gems"] = {},
					}
					YssCompare.db.profile.WeightSet = val
					YssCompare:SetupStatOptions()
					wipe(IPcache)
				end,
			},
			WeightSet = {
				name = "Current Weight Set:",
				type = 'select',
				order = 110,
				width = 'full',
				values = function()
					local WeightSets = {}
					for set in pairs(YssCompare.sets) do
						WeightSets[set] = set
					end
					return WeightSets
				end,
				get = function(info)
					return YssCompare.db.profile.WeightSet
				end,
				set = function(info,val)
					YssCompare.db.profile.WeightSet = val
					YssCompare:SetupStatOptions()
					wipe(IPcache)
				end,
			},
			DeleteSet = {
				name = "Delete Set:",
				order = 120,
				type = 'select',
				width = 'full',
				values = function()
					local WeightSets = {}
					for set in pairs(YssCompare.sets) do
						WeightSets[set] = set
					end
					WeightSets['Default'] = nil
					return WeightSets
				end,
				confirm = function(info, val) 
					return string.format("Are you sure you want to delete |cffff0000%s|r?", val)
				end,
				set = function(info, val)
					YssCompare.sets[val] = nil
					if YssCompare.db.profile.WeightSet == val then
						YssCompare.db.profile.WeightSet = 'Default'
					end
					YssCompare:SetupStatOptions()
					wipe(IPcache)
				end,
			},
			blacklist = {
				name = "Remove Item From Exact Blacklist:",
				order = 130,
				type = 'select',
				width = 'double',
				values = function()
					local list = {}
					for item in pairs(YssCompare.db.profile.blacklist) do
						list[item] = item
					end
					return list
				end,
				confirm = function(info,val)
					return string.format("Are you sure you want to remove %s from the Exact Blacklist?", val)
				end,
				disabled = function()
					return not next(YssCompare.db.profile.blacklist)
				end,
				set = function(info, val)
					YssCompare.db.profile.blacklist[val] = nil
					YssCompare:RefreshTooltip()
				end,
			},
			blacklistID = {
				name = "Remove Item From ID Blacklist:",
				order = 140,
				type = 'select',
				width = 'double',
				values = function()
					local list = {}
					for id in pairs(YssCompare.db.profile.blacklistID) do
						local _, item = GetItemInfo(id) 
						list[item] = item
					end
					return list
				end,
				confirm = function(info,val)
					return string.format("Are you sure you want to remove %s from the ID Blacklist?", val)
				end,
				disabled = function()
					return not next(YssCompare.db.profile.blacklistID)
				end,
				set = function(info, val)
					local id = string.match(val, 'item:(%d+)')
					YssCompare.db.profile.blacklistID[id] = nil
					YssCompare:RefreshTooltip()
				end,
			},
			
			SetSetup = {
				name = 'Set Setup',
				type = 'group',
				order = 200,
				inline = true,
			},
			
			test = {
				name = 'Test',
				order = -1,
				type = "execute",
				func = function(info)
					YssCompare:Print("Hello World")
					YssCompare:Print(StatLogic:GetGemID('Bold Scarlet Ruby'))
					YssCompare:Print(StatLogic:GetGemID('39996'))
					YssCompare:Print(StatLogic:GetGemID(39996))
					YssCompare:Print(GetItemInfo('Bold Scarlet Ruby'))
					YssCompare:Print(GetItemInfo('39996'))
					YssCompare:Print(GetItemInfo(39996))
				end,
			},
		},
	}
end

do
	local IncSetQue = {}
	local IncNameQue = {}
	local IncSenderQue = {}
	function YssCompare:OnCommReceived(prefix,msg,distribution,sender)
		local test, name, set = YssCompare:Deserialize(msg)
		if test then
			IncSetQue[#IncSetQue+1] = set
			IncNameQue[#IncNameQue+1] = name
			IncSenderQue[#IncSenderQue+1] = sender
			YssCompare:ConfirmIncomming()
		end
	end
	
	function YssCompare:ConfirmIncomming()
		if not StaticPopupDialogs["YssCompare_Incomming"] then
			StaticPopupDialogs["YssCompare_Incomming"] = {
				text = 'nil',
				button1 = "Yes",
				button2 = "No",
				timeout = 0,
				whileDead = 1,
				hideOnEscape = 1,
				OnAccept = function()
					StaticPopupDialogs["YssCompare_Incomming"].text = 'nil'
					YssCompare.sets[string.format("%s - %s - %s", table.remove(IncSenderQue, 1), table.remove(IncNameQue, 1), date("%m/%d/%y %H:%M:%S"))] = table.remove(IncSetQue, 1)
				end,
				OnCancel = function()
					StaticPopupDialogs["YssCompare_Incomming"].text = 'nil'
					table.remove(IncSetQue, 1)
					table.remove(IncNameQue, 1)
					table.remove(IncSenderQue, 1)
				end,
				OnHide = function()
					YssCompare:ConfirmIncomming()
				end,
			}
		end
		if StaticPopupDialogs["YssCompare_Incomming"].text ~= 'nil' or not IncSetQue[1] then return end
		StaticPopupDialogs["YssCompare_Incomming"].text = string.format('Do you want to add the |cff0080ff%s|r Weight Set sent to you by |cff0080ff%s|r to your set list?', IncNameQue[1], IncSenderQue[1])
		StaticPopup_Show("YssCompare_Incomming")
	end
	
	local selectedSet
	local selectedName
	YssCompare.ShareOptions = {
		type="group",
		childGroups = 'select',
		handler = YssCompare,
		args = {
			Set = {
				name = "Set to Send:",
				order = 100,
				type = 'select',
				values = function()
					local WeightSets = {}
					for set in pairs(YssCompare.sets) do
						WeightSets[set] = set
					end
					WeightSets['Default'] = nil
					return WeightSets
				end,
				get = function()
					return selectedSet
				end,
				set = function(info, val)
					selectedSet = val
				end,
			},
			Name = {
				name = "Set Destination",
				order = 200,
				type = 'input',
				get = function()
					return selectedName
				end,
				set = function(info, val)
					selectedName = val
				end,
			},
			Send = {
				name = "Send Set",
				order = 300,
				type = 'execute',
				confirm = function()
					return string.format('Are you sure that you want to send |cffff8000%s|r to |cffff8000%s|r?', selectedSet, selectedName)
				end,
				disabled = function()
					return not(selectedSet and selectedName)
				end,
				func = function()
					local msg = YssCompare:Serialize(selectedSet, YssCompare.sets[selectedSet])
					YssCompare:SendCommMessage('YComp', msg, 'WHISPER', selectedName)
					selectedSet = nil
					selectedName = nil
				end,
			},
		},
	}
end



YssCompare.optframe = {}
LibStub("AceConfig-3.0"):RegisterOptionsTable('YssCompareConfig', YssCompare.MainOption)
YssCompare.optframe.YssCompare = LibStub("AceConfigDialog-3.0"):AddToBlizOptions('YssCompareConfig', 'YssCompare')
-- function addapted from the RegisterModuleOptions function in Mapster
function YssCompare:RegisterModuleOptions(name, optionTbl, displayName)
	local cname = "YssCompareConfig_"..name
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable(cname, optionTbl)
	self.optframe[name] = LibStub("AceConfigDialog-3.0"):AddToBlizOptions(cname, displayName, "YssCompare")
end

